#include <windows.h>
#include "Hook.hpp"


static HHOOK     Hook;
static HINSTANCE Library;


////////////////////////////////////////////////////////////////////////////////

bool SetHook()
{
  Library = LoadLibrary("MouseHook.dll");
  if (Library == NULL) {
    return false;
  }
  
  HOOKPROC MouseProc = (HOOKPROC)GetProcAddress(Library, "MouseProc");
  if (!MouseProc) {
    FreeLibrary(Library);
    return false;
  }

  Hook = SetWindowsHookEx(WH_MOUSE_LL, MouseProc, Library, 0);
  if (Hook == NULL) {
    FreeLibrary(Library);
    return false;
  }

  return true;
}

////////////////////////////////////////////////////////////////////////////////

void RemoveHook()
{
  UnhookWindowsHookEx(Hook);
  FreeLibrary(Library);
}

////////////////////////////////////////////////////////////////////////////////
